-- name=int_panel_social_share
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Share = function () end
};

local _this = {
  int    = "int_panel_social_share",
  obj    = "obj_int_panel_social_share",
  panel  = "anm_int_panel_social_share",
  body   = "anm_int_panel_social_share_body",
  button = {
    share = "btn_int_panel_social_share_share"
  }
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  _this.app_h = ui.screen.Height();
  _this.app_w = ui.screen.Width();
  _this.app_o = ui.screen.Orientation();

  private.Adapt();
  private.CreateButtons();

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()
  
  ui.hub.Create( _this.int );

  local multiset = {};
  
  local position = {
    portrait  = { _this.app_w / 2, _this.app_h     },
    landscape = { _this.app_w,     _this.app_h / 2 }
  };

  local dimens = {
    w = 600,
    h = 180
  };
  
  ui.obj.Set(
    _this.obj,
    {
      pos_x          = position[ _this.app_o ][ 1 ],
      pos_y          = position[ _this.app_o ][ 2 ],
      inputrect_init = true,
      inputrect_x    = dimens.w / -2,
      inputrect_w    = dimens.w,
      inputrect_y    = dimens.h / -2,
      inputrect_h    = dimens.h
    },
    multiset
  );

  ui.obj.Set(
    _this.body,
    {
      tt_description = "str_int_panel_social_share_description"
    },
    multiset
  );

  ui.obj.Multiset( multiset );

end;
--------------------------------------------------------------------------------
function private.CreateButtons ()
  
  ui.button.Create(
    _this.button.share,
    {
      title  = "str_int_panel_social_share_share",
      design = "facebook",
    },
    function() _f.Share(); end
  );
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ()

  if ( _this.is_active ) then return; end;
  
  _this.is_active = true;

  ui.hub.AttachContent( _this.int );

  ui.anim.Play( _this.panel, "appear_panel" );
  
end;
--------------------------------------------------------------------------------
function public.Hide ()

  if ( not _this.is_active ) then return; end;
  
  _this.is_active = false;

  ui.anim.Play(
    _this.panel,
    "disappear_panel",
    function() ui.hub.DetachContent( _this.int ); end
  );

end;
--------------------------------------------------------------------------------
function public.IsActive ()

  return _this.is_active;

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.SetDefault ()

  --

end;
--------------------------------------------------------------------------------