-- name=int_panel_stage_time
--********************************************************************************************************************
--********************************************************************************************************************
function public.__InitObjects ()

  ui.hub.Create( "int_panel_stage_time" );

  ObjSet( "obj_int_panel_stage_time",
  {
    pos_x = GetAppWidth() - 55,
    pos_y = 0
  } );
  
end;
--********************************************************************************************************************
--********************************************************************************************************************
function public.Show ( time, func_change_time, func_continue )

  ui.hub.AttachContent( "int_panel_stage_time" );

  private.ChangeTime = func_change_time;

  private.Continue = func_continue;

  ObjStopAnimate( "txt_int_panel_stage_time", "scale_xy" );

  ObjSet( "int_panel_stage_time", { active = true, visible = true } );

  private.ShowTime( time );

  private.active = true;

  private.window_count = 0;

end;
--********************************************************************************************************************
--********************************************************************************************************************
function public.Hide ()

  private.active = false;

  ui.hub.DetachContent( "int_panel_stage_time" );

  ObjSet( "int_panel_stage_time", { active = false, visible = false } );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function public.Update ( time )

  if ( not private.active ) then

    return;

  end;

  private.ShowTime( time );

  local tme = 0.05;

  if ( time < 5 ) then

    ObjAnimate( "txt_int_panel_stage_time", "scale_xy", 1, 0, "",
    { 
      0.0, 0, 1.0, 1.0,
      0.4, 0, 1.2, 1.2,
      0.8, 0, 1.0, 1.0,
    } );

    ObjAnimate( "txt_int_panel_stage_time_count", "scale_xy", 0, 0, "",
    {
      tme * 0, 3, 1.00, 1.00,
      tme * 1, 3, 1.20, 1.20,
      tme * 3, 3, 0.80, 0.80,

      tme * 5, 3, 1.15, 1.15,
      tme * 7, 3, 0.85, 0.85,

      tme * 9, 3, 1.10, 1.10,
      tme *11, 3, 0.90, 0.90,

      tme *13, 3, 1.05, 1.05,
      tme *15, 3, 0.95, 0.95,

      tme *16, 3, 1.00, 1.00,
    } );

  else

    ObjStopAnimate( "txt_int_panel_stage_time", "scale_xy" );
    ObjSet( "txt_int_panel_stage_time", { scale_x = 1, scale_y = 1 } );

  end;

end;
--********************************************************************************************************************
--********************************************************************************************************************
function public.StartTimer ()

  if ( not private.active ) then

    return;

  end;

  if ( private.window_count > 0 ) then

    private.window_count = private.window_count - 1;

  end;

  if ( private.window_count > 0 ) then

    return;    

  end;

  local timer = "tmr_int_panel_stage_time_timer";

  ObjSet( timer,
  {
    time = 1.0,
    playing = true,
    endtrig = function()

      if ( private.ChangeTime( - 1 ) ) then

        public.StartTimer();

      else

        private.Continue();

      end;

    end;
  } );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function public.StopTimer ()

  if ( not private.active ) then

    return;

  end;

  private.window_count = private.window_count + 1;

  local timer = "tmr_int_panel_stage_time_timer";

  ObjSet( timer, { playing = false } );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.ShowTime ( time )

  local raw = math.floor( time % 60 );
  local sec;

  if ( raw < 10 ) then

    sec = "0"..raw;

  else
    
    sec = raw;
    
  end;

  ObjSet( "txt_int_panel_stage_time_count", { text = "str_int_panel_stage_timer", param0 = math.floor( time / 60 ), param1 = sec } );

end;
--********************************************************************************************************************
--********************************************************************************************************************