-- name=int_popup_stage_bonus
--------------------------------------------------------------------------------
function public.__InitModule ()

  private.anim_time = 0.3;
  
  private.pos_x = 250;
  private.pos_y = 250;
  
end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  ui.hub.Create( "int_popup_stage_bonus" );

end;
--------------------------------------------------------------------------------
function public.SetPos ( x, y )
  
  private.pos_x = x;
  private.pos_y = y;
  
end;
--------------------------------------------------------------------------------
function public.Show ( chip_types, stage_type, target, ability, func_show )

  if ( private.active ) then

    return;

  end;

  ui.hub.AttachContent( "int_popup_stage_bonus" );
  
  ObjSet( "obj_int_popup_stage_bonus", { active = true, visible = true } );

  private.SetDefault( chip_types, stage_type, target, ability );

  local tme = private.anim_time;

  ObjAnimate( "obj_int_popup_stage_bonus", "scale_xy", 0, 0, func_show, 
  { 
    0.0, 0, 0, 0, 
    tme, 0, 1, 1 
  } );

   common.sound.Play( "desire" );

  private.active = true;
  
end;
--------------------------------------------------------------------------------
function public.Hide ( completed )

  if not ( private.active ) then

    return;

  end;

  private.active = false;

  local multiset_table = {};

  for i = 1, 3 do

    table.insert( multiset_table, { "spr_int_popup_stage_bonus_icon_"..i, { visible = false } } );

  end;

  local animfunc = "icon_reject";

  if ( completed ) then

    animfunc = "icon_done";

  end;

  local func_end = function ()

    local func_end_anim = function () 

      ObjSet( "obj_int_popup_stage_bonus", { active = false, visible = false } );

      ui.hub.DetachContent( "int_popup_stage_bonus" ); 

    end;

    local tme = private.anim_time;

    ObjAnimate( "obj_int_popup_stage_bonus", "scale_xy", 0, 0, func_end_anim, 
    { 
      0.0, 0, 1, 1, 
      tme, 0, 0, 0 
    } );

  end;

  if ( completed == nil ) then

    func_end();

    return;

  end;

  table.insert( multiset_table, { "spr_int_popup_stage_bonus_icon_check", { animfunc = animfunc, playing = true, visible = true } } );
  table.insert( multiset_table, { "obj_int_popup_stage_bonus_ability", { visible = false } } );

  ObjMultiSet( multiset_table );

  ObjAnimate( "obj_int_popup_stage_bonus", "pos_z", 0, 0, func_end, 
  {
    0.0, 0, 0,
    0.6, 0, 0
  } );

end;
--------------------------------------------------------------------------------
function private.SetDefault ( chip_types, stage_type, target, ability )
  
  local pop_scale  = { 1.2,  1.0 };
  
  local chip_scale = 0.8;
  local chip_pos   = 
  {
    { { - 38,  0, 0 } },
    { {   18, 10, 1 }, { - 10, - 12, 0 } },
    { { - 14, 16, 2 }, {   24,    8, 1 }, { - 10, - 20, 0 } },
  };

  local multiset_table = {};

  for i = 1, 3 do

    table.insert( multiset_table, { "spr_int_popup_stage_bonus_icon_"..i, { visible = false } } );

  end;

  for i = 1, #chip_types do

    table.insert( multiset_table, { "spr_int_popup_stage_bonus_icon_"..i, 
    { 
      visible  = true, 
      animfunc = "chip_"..string.lower( chip_types[ i ] ), 
      playing  = true,
      scale_x  = chip_scale,
      scale_y  = chip_scale,
      pos_x    = chip_pos[ #chip_types ][ i ][ 1 ],
      pos_y    = chip_pos[ #chip_types ][ i ][ 2 ],
      pos_z    = chip_pos[ #chip_types ][ i ][ 3 ]
    } } );

  end;

  table.insert( multiset_table, { "spr_int_popup_stage_bonus_icon_check", { visible = false } } );

  table.insert( multiset_table, { "obj_int_popup_stage_bonus",    { pos_x = private.pos_x, pos_y = private.pos_y   } } );
  table.insert( multiset_table, { "spr_int_popup_stage_bonus_bg", { scale_x = pop_scale[1], scale_y = pop_scale[2] } } );

  if ( ability ) then

    table.insert( multiset_table, { "obj_int_popup_stage_bonus_ability",           { visible = true } } );
    table.insert( multiset_table, { "txt_int_popup_stage_bonus_ability",           { text = "" --[[ability or ""]] } } );
    table.insert( multiset_table, { "spr_int_popup_stage_bonus_ability",           { animfunc = "icon_"..ability, playing = true } } );
    table.insert( multiset_table, { "spr_int_popup_stage_bonus_ability_remove",    { visible = false } } );
  
  else

    table.insert( multiset_table, { "obj_int_popup_stage_bonus_ability",    { visible = false } } );

  end;

  if ( target == "enemy" ) then

    table.insert( multiset_table, { "spr_int_popup_stage_bonus_ability_remove",    { visible = true } } );

  end;

  ObjMultiSet( multiset_table );

end;
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------