-- name=v_story
--------------------------------------------------------------------------------
local _modules = {
  "m_story",
  "int_dialog_story"
};
--------------------------------------------------------------------------------
function public.__GetDependencies ()

  return _modules;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  common.mod.Load( _modules );
  
  v_interface.window.RegisterAsFullscreen( "int_dialog_story" );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.TryShow ( section_name, cond_type, cond_name, func_after )

  if not ( section_name ) then 

    if ( func_after ) then func_after(); end;
    return false;

  end;

  local story_data = m_story.GetData( section_name, cond_type, cond_name );
  local func_story = public.Callback_ShowStory( story_data, "stage" );

  if ( func_story ) then
  
    func_story( func_after );
    return true;

  elseif ( func_after ) then

    func_after();

  end;
  
  return false;

end;
--------------------------------------------------------------------------------
function public.Callback_ShowStory ( story_data, point )

  if ( story_data ) then

    return function ( func_after )
    
      local delegates = {

        Close = function ()
          
          local function func_anim_end ( func_after_end )

            int_dialog_story.Hide(
              function ()
                v_interface.window.Hide( "int_dialog_story" );
                if ( func_after_end ) then func_after_end(); end;
              end,
              true
            );

          end;
          
          if ( point == "stage" ) then 
            mediator.SubscribeOnce(
              "View_Interface_LoadingSplashIsShown",
              func_anim_end
            );
            if ( func_after ) then func_after(); end;
          else
            func_anim_end( func_after );
          end;
        
        end

      };

      common.delegate.Set( "int_dialog_story", delegates );
      
      v_interface.panel.top.Hide( true );
      v_interface.window.Show(
        "int_dialog_story",
        function ()

          int_dialog_story.Show( story_data );

        end
      );
    
    end;
  
  end;

  return nil;

end;
--------------------------------------------------------------------------------
function public.GetData ( section, cond_type, cond_name )

  local story_data = m_story.GetData( section, cond_type, cond_name );
  
  return story_data;

end;
--------------------------------------------------------------------------------